<%-- $Id: edit_anytoany.jsp 6414 2014-02-05 09:57:05Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.AnyToAny"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.Subtypable"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemNotFoundException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
	import="java.util.Arrays"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%!
private String getName(BasicItem item, boolean readItem, boolean missingItem, Item itemType, int id)
{
	String name = "";
	if (item instanceof File)
	{
		File toFile = (File)item;
		name = HTML.encodeTags(toFile.getPath().toString());
	}
	else if (item instanceof Nameable)
	{
		Nameable nameable = (Nameable)item;
		name = HTML.encodeTags(nameable.getName());
	}
	else if (!readItem)
	{
		name = "<i>- denied -</i>";
	}
	else if (missingItem)
	{
		name = "<i>- missing -</i> (" + itemType.toString() + "; id=" + id + ")";
	}
	else if (item == null)
	{
		name = "<i>- none -</i>";
	}
	else
	{
		name = HTML.encodeTags(item.toString());
	}
	if (item != null)
	{
		String subtype = item.getType().toString();
		if (item instanceof Subtypable)
		{
			try
			{
				ItemSubtype st = ((ItemSubtype)item).getItemSubtype();
				if (st != null) subtype = st.getName();
			}
			catch (RuntimeException ex)
			{}
		}
		name += " <span class=\"itemsubtype\">(" + item.getType() + ")</span>";
	}
	return name;
}

%>
<%
final Item itemType = Item.ANYTOANY;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	AnyToAny anyToAny = null;

	Item fromType = null;
	int fromId = 0;
	String fromName = "";
	String toName = "";
	
	if (itemId == 0)
	{
		cc.removeObject("item");
		fromType = Item.valueOf(request.getParameter("from_type"));
		fromId = Values.getInt(request.getParameter("from_id"));
		BasicItem from = fromType.getById(dc, fromId);
		from.checkPermission(Permission.WRITE);
		fromName = getName(from, true, false, fromType, fromId);
		toName = "<i>- none -</i>";
		title = "New link";
	}
	else
	{
		anyToAny = AnyToAny.getById(dc, itemId);
		cc.setObject("item", anyToAny);
		title = "Edit any-to-any link -- " + HTML.encodeTags(anyToAny.getName());
		fromType = anyToAny.getFromType();
		fromId = anyToAny.getFromId();
		
		BasicItem to = null;
		boolean readTo = true;
		boolean missingTo = false;
		
		BasicItem from = null;
		boolean readFrom = true;
		boolean missingFrom = false;
		
		try
		{
			to = anyToAny.getTo();
		}
		catch (PermissionDeniedException ex)
		{
			readTo = false;
		}
		catch (ItemNotFoundException ex)
		{
			missingTo = true;
		}
		
		try
		{
			from = anyToAny.getFrom();
		}
		catch (PermissionDeniedException ex)
		{
			readFrom = false;
		}
		catch (ItemNotFoundException ex)
		{
			missingFrom = true;
		}
	
		toName = getName(to, readTo, missingTo, anyToAny.getToType(), anyToAny.getToId());
		fromName = getName(from, readFrom, missingFrom, fromType, fromId);
	}
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol-2.js,~edit.js" styles="tabcontrol.css" />
	<base:body>
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="anytoany">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="from_type" value="<%=fromType.name() %>">
		<input type="hidden" name="from_id" value="<%=fromId %>">
		<%
		if (anyToAny != null)
		{
			%>
			<input type="hidden" name="to_type" value="<%=anyToAny.getToType().name()%>">
			<%
		}
		%>
		<input type="hidden" id="to_id" name="to_id" value="<%=anyToAny == null ? 0 : -anyToAny.getToId()%>">

		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol"
			position="bottom" remember="<%=anyToAny != null%>">
		<t:tab id="info" title="Any-to-any link" helpid="anytoany.edit">
			<table class="fullform input100 smaller">
			<tr>
				<th>From</th>
				<td><%=fromName%></td>
				<td></td>
			</tr>
			<tr>
				<th>Name</th>
				<td><input class="text required auto-init" type="text" name="name" data-auto-init="<%=anyToAny == null ? "focus-select" : "focus" %>"
					value="<%=HTML.encodeTags(anyToAny == null ? Values.getString(cc.getPropertyValue("name"), "New link") : anyToAny.getName())%>" 
					maxlength="<%=AnyToAny.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<%
			if (anyToAny == null)
			{
				%>
				<tr>
					<th>Target type</th>
					<td>
						<select name="to_type" style="width: 20em;" class="required unchangeable">
						<%
						List<String> recentTypes = cc.getRecent("toTypes");
						if (recentTypes.size() == 0)
						{
							recentTypes = Arrays.asList("FILE");
						}
						%>
						<option value="0" disabled class="recentheader">- recently used -
						<%
						for (String r : recentTypes)
						{
							%>
							<option value="<%=r%>"><%=r%>
							<%
						}
						%>
						<option value="0" disabled class="recentheader">- all -
						</select>
					</td>
					<td></td>
				</tr>
				<%
			}
			%>
			<tr>
				<th>Target item</th>
				<td >
					<table style="width: 100%;">
					<tr>
					<td id="toName"><%=toName%></td>
					<td style="width: 8em;"><base:button title="Select" id="btnSelect" /></td>
					</tr>
					</table>
				</td>
				<td></td>
			</tr>
			<tr>
				<th><label for="blockRemoval">Block removal</label></th>
				<td><input type="checkbox" id="blockRemoval" name="block_removal" value="1" <%=anyToAny != null && anyToAny.isUsingTo() ? "checked" : "" %>>
					<i>(if checked, the selected item is blocked for deletion)</i>
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="6" name="description" id="description"
						><%=HTML.encodeTags(anyToAny == null ? cc.getPropertyValue("description") : anyToAny.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
			<%if (anyToAny == null) {%><br>
				<base:icon image="unchangeable.png" />= can't be changed later
			<%}%>
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" disabled="<%=anyToAny != null && !anyToAny.hasPermission(Permission.WRITE) %>"/>
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
