<%-- $Id $
	------------------------------------------------------------------
	Copyright (C) 2013 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	BASE is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@page %>
<%@ page pageEncoding="UTF-8" session="false" contentType="application/json" 
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.VirtualDb"
	import="net.sf.basedb.core.ReporterCloneTemplate"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawDataTypes"
	import="net.sf.basedb.core.RawDataProperty"
	import="net.sf.basedb.core.ExtendedProperty"
	import="net.sf.basedb.core.ExtendedProperties"
	import="net.sf.basedb.core.Formula"
	import="net.sf.basedb.core.IntensityTransform"
	import="net.sf.basedb.core.ClonableProperty"
	import="net.sf.basedb.core.ReporterList"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.util.jep.Jep"
	import="net.sf.basedb.util.jep.SimpleJepFunction"
	import="net.sf.basedb.util.jep.JepFunction"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.DynamicUtil"
	import="net.sf.basedb.clients.web.taglib.table.TableColumn"
	import="net.sf.basedb.util.error.ThrowableUtil"
	import="java.util.Stack"
	import="java.util.List"
	import="java.util.LinkedList"
	import="java.util.HashSet"
	import="java.util.Set"
	import="java.util.Arrays"
	import="org.json.simple.JSONObject"
	import="org.nfunk.jep.JEP"
	import="org.nfunk.jep.ParseException"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%!

	private static Set<String> staticRawProperties = 
		new HashSet<String>(Arrays.asList("position", "block", "metaGridX", "metaGridY", 
			"row", "column", "x", "y"));

	private static void checkRawProperty(String functionName, Object property, RawDataType rawDataType)
		throws ParseException
	{
		if (property == null)
		{
			throw new ParseException("Function " + functionName + " requires a single parameter");
		}
		if (rawDataType == null)
		{
			throw new ParseException("Cannot use function " + functionName + ". No raw data type selected.");
		}
		RawDataProperty rp = rawDataType.getProperty(property.toString());
		if (rp == null && !staticRawProperties.contains(property))
		{
			throw new ParseException("Property '"+property+"' not found for raw data type '" + rawDataType.getName() + "'.");
		}
	}

	private static void checkChannel(String functionName, Object channel, int numChannels)
		throws ParseException
	{
		if (channel == null)
		{
			throw new ParseException("Function " + functionName + " requires a single parameter");
		}
		int channelNum = channel instanceof Number ? ((Number)channel).intValue() : 0;
		if (channelNum <= 0 || channelNum > numChannels) 
		{
			throw new ParseException("Invalid channel: " + channel + "; must be between 1 and "+ numChannels);
		}
	}
%>
<%
	final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
	final Formula.Type formulaType = Formula.Type.valueOf(request.getParameter("formulatype"));
	final RawDataType rawDataType = RawDataTypes.getRawDataType(request.getParameter("rawdatatype"));
	int bioAssaySetId = Values.getInt(request.getParameter("bioassayset_id"), -1);
	boolean restrictions = Values.getBoolean(request.getParameter("restrictions"));
	final int channels = Values.getInt(request.getParameter("channels"));
	final String expression = request.getParameter("expression");
	
	JSONObject json = new JSONObject();
	json.put("status", "ok");
	DbControl dc = null;
	
	
	JepFunction raw = new SimpleJepFunction("raw", 1)
	{
		@Override
		public void run(Stack stack)
			throws ParseException
		{
			Object property = stack.pop();
			checkRawProperty(getFunctionName(), property, rawDataType);
			stack.push(Math.random()*100);
		}
	};
	
	JepFunction mean = new SimpleJepFunction("mean", 1)
	{
		@Override
		public void run(Stack stack)
			throws ParseException
		{
			Object property = stack.pop();
			checkRawProperty(getFunctionName(), property, rawDataType);
			stack.push(Math.random()*100);
		}
	};
	
	JepFunction ch = new SimpleJepFunction("ch", 1)
	{
		@Override
		public void run(Stack stack)
			throws ParseException
		{
			Object channel = stack.pop();
			checkChannel(getFunctionName(), channel, channels);
			stack.push(Math.random()*100);
		}
	};
	
	JepFunction rawCh = new SimpleJepFunction("rawCh", 1)
	{
		@Override
		public void run(Stack stack)
			throws ParseException
		{
			Object channel = stack.pop();
			checkChannel(getFunctionName(), channel, channels);
			stack.push(Math.random()*100);
		}
	};
	
	if (formulaType == Formula.Type.INTENSITY_EXPRESSION) 
	{
		ch = null;
		rawCh = null;
	}
	
	JepFunction pos = new SimpleJepFunction("pos", 0)
	{
		@Override
		public void run(Stack stack)
			throws ParseException
		{
			stack.push((int)(Math.random()*1000));
		}
	};
	
	JepFunction rep = new SimpleJepFunction("rep", 1)
	{
		@Override
		public void run(Stack stack)
			throws ParseException
		{
			Object property = stack.pop();
			if (property == null)
			{
				throw new ParseException("Function rep() requires a single parameter");
			}
			ClonableProperty cp = null;
			try
			{
				cp = ClonableProperty.create(property.toString());
			}
			catch (RuntimeException ex)
			{}
			if (cp == null)
			{
				throw new ParseException("Property '"+property+"' not found for reporter.");
			}

			stack.push(Math.random()*100);
		}
	};
	
	JepFunction score = new SimpleJepFunction("score", 1);
	JepFunction xtra = new SimpleJepFunction("xtra", 1);

	try
	{
		JEP jep = Jep.newJep(expression, raw, mean, ch, rawCh, pos, rep, score, xtra);
		if (jep.getSymbolTable().containsKey("null"))
		{
			jep.setVarValue("null", 0);
		}
		json.put("value", jep.getValueAsObject());
		/*
		if (jep.hasError())
		{
			throw new ParseException(jep.getErrorInfo());
		}
		*/
	}
	catch (Throwable t)
	{
		t.printStackTrace();
		json.clear();
		json.put("status", "error");
		json.put("message", t.getMessage());
		json.put("stacktrace", ThrowableUtil.stackTraceToString(t));
	}
	finally
	{
		json.writeJSONString(out);
		out.flush();
		if (dc != null) dc.close();
	}

%>