<%-- $Id: view_design.jsp 6610 2014-11-20 11:48:06Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.FileSet"
	import="net.sf.basedb.core.FileSetMember"
	import="net.sf.basedb.core.DataFileType"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.ArrayDesign"
	import="net.sf.basedb.core.ArrayBatch"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.ArrayDesignPlate"
	import="net.sf.basedb.core.Plate"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ChangeHistoryUtil"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Collections"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.ARRAYDESIGN;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String root = request.getContextPath()+"/";
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String tab = Values.getString(request.getParameter("tab"), "properties");
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	ArrayDesign design = ArrayDesign.getById(dc, itemId);
	Job job = null;
	boolean readJob = true;
	try
	{
		job = design.getJob();
	}
	catch (PermissionDeniedException ex)
	{
		readJob = false;
	}
	final Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);

	final boolean usePermission = design.hasPermission(Permission.USE);
	final boolean writePermission = design.hasPermission(Permission.WRITE);
	final boolean deletePermission = design.hasPermission(Permission.DELETE);
	final boolean sharePermission = design.hasPermission(Permission.SET_PERMISSION);
	final boolean setOwnerPermission = design.hasPermission(Permission.SET_OWNER);
	final boolean isRemoved = design.isRemoved();
	final boolean isUsed = isRemoved && design.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	final boolean isOwner = design.isOwner();
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, design);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>" id="view-page">
	<base:head scripts="table.js,tabcontrol-2.js,~designs.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<p:path><p:pathelement 
			title="Array designs" href="<%="index.jsp?ID="+ID%>" 
			/><p:pathelement title="<%=HTML.encodeTags(design.getName())%>" 
			/></p:path>
		<div id="page-data" data-item-id="<%=itemId%>"></div>
		
		<t:tabcontrol 
			id="main" 
			subclass="content mastertabcontrol" 
			active="<%=tab%>">
		<t:tab id="properties" title="Properties">
			<div>
			<table class="fullform">
			<tr>
				<th class="itemstatus">
					<base:icon 
						image="shared.png" 
						visible="<%=design.isShared()%>"
						tooltip="This item is shared to other users, groups and/or projects"
					/>
					<base:icon 
						id="btnDeletePermanently"
						image="deleted.png"
						tooltip="This item has been flagged for deletion. Click to delete it now."
						enabled="<%=deletePermanentlyPermission %>"
						visible="<%=isRemoved%>" 
					/>
					<base:icon 
						id="btnUsingItems"
						image="used.png" 
						tooltip="This item is used by other items and can't be permanently deleted. Show the items that are using this one"
						visible="<%=isRemoved && isUsed%>" />
				</th>
				<td style="padding: 0px;">
					<tbl:toolbar subclass="bottomborder bg-filled-50">
						<tbl:button 
							id="btnEdit"
							disabled="<%=!writePermission%>" 
							image="edit.png" 
							title="Edit&hellip;" 
							tooltip="<%=writePermission ? "Edit this array design" : "You do not have permission to edit this array design"%>" 
						/>
						<tbl:button 
							id="btnDelete"
							disabled="<%=!deletePermission%>" 
							image="delete.png" 
							title="Delete"
							visible="<%=!design.isRemoved()%>"
							tooltip="<%=deletePermission ? "Delete this array design" : "You do not have permission to delete this array design"%>" 
						/>
						<tbl:button 
							id="btnRestore"
							disabled="<%=!writePermission%>" 
							image="restore.png" 
							title="Restore"
							visible="<%=design.isRemoved()%>"
							tooltip="<%=writePermission ? "Restore this array design" : "You do not have permission to restore this array design"%>" 
						/>
						<tbl:button 
							id="btnShare"
							disabled="<%=!sharePermission%>"
							image="share.png"
							title="Share&hellip;" 
							tooltip="<%=sharePermission ? "Share this array design to other user, groups and projects" : "You do not have permission to share this array design"%>"
						/>
						<tbl:button 
							id="btnSetOwner"
							disabled="<%=!setOwnerPermission%>"
							image="take_ownership.png"
							title="Set owner&hellip;"
							tooltip="<%=setOwnerPermission ? "Change owner of this item" : "You do not have permission to change ownership of this item"%>"
						/>
						<tbl:button
							id="btnNewBatch"
							image="add.png"
							title="New batch&hellip;"
							tooltip="Create a new array batch with this design"
							visible="<%=sc.hasPermission(Permission.CREATE, Item.ARRAYBATCH) && usePermission%>"
						/>
						<tbl:button 
							id="btnImport"
							image="import.png" 
							data-plugin-type="IMPORT"  
							title="Import&hellip;" 
							tooltip="Import data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
						/>
						<tbl:button 
							id="btnExport"
							image="export.png"
							data-plugin-type="EXPORT" 
							title="Export&hellip;" 
							tooltip="Export data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
						/>
						<tbl:button 
							id="btnRunPlugin"
							image="runplugin.png"  
							data-plugin-type="OTHER" 
							title="Run plugin&hellip;" 
							tooltip="Run a plugin" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
						/>
						<tbl:button 
							id="btnManagePlates"
							title="Manage plates&hellip;"
							tooltip="Attach / detach plates to this array design"
							visible="<%=writePermission && !design.hasFeatures()%>"
						/>
						<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
							wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
						<tbl:button
							image="help.png"
							subclass="auto-init"
							data-auto-init="help"
							data-help-id="arraydesign.view.properties"
							title="Help&hellip;"
							tooltip="Get help about this page"
						/>
					</tbl:toolbar>
				</td>
			</tr>
		</table>
		<table style="width: 100%; height: 18em;" class="bottomborder">
		<tr>
			<td style="width: 50%; height: 100%;">
				<table class="fullform" >
				<tr>
					<th>Name</th>
					<td><%=HTML.encodeTags(design.getName())%></td>
				</tr>
				<tr>
					<th>Registered</th>
					<td><%=dateFormatter.format(design.getEntryDate())%></td>
				</tr>
				<tr>
					<th>Platform</th>
					<td><base:propertyvalue item="<%=design%>" property="platform" /></td>
				</tr>
				<tr>
					<th>Variant</th>
					<td><base:propertyvalue item="<%=design%>" property="variant" /></td>
				</tr>
				<tr>
					<th>Arrays per slide</th>
					<td><%=design.getNumArrays()%></td>
				</tr>
				<tr>
					<th>Features</th>
					<td><%=design.hasFeatures() ? "yes (db: " + design.getNumDbFeatures() + "; file: " + design.getNumFileFeatures() + ")" : "no"%></td>
				</tr>
				<tr>
					<th>Feature identification method</th>
					<td><%=design.getFeatureIdentificationMethod()%></td>
				</tr>
				<tr>
					<th>Owner</th>
					<td><base:propertyvalue item="<%=design%>" property="owner" /></td>
				</tr>
				<tr>
					<th>Permissions</th>
					<td><%=PermissionUtil.getFullPermissionNames(design)%></td>
				</tr>
				<tr>
					<th>Description</th>
					<td><%=HTML.niceFormat(design.getDescription())%></td>
				</tr>
				</table>
			</td>
			<td style="width: 50%; height: 100%;" class="leftborder">
				<table class="fullform larger">
				<tbody class="sectionheader">
					<tr>
						<th colspan="2">Feature import</th>
					</tr>
				</tbody>
				<tr>
					<th>Job</th>
					<td><%=Base.getLinkedName(ID, job, !readJob, true)%></td>
				</tr>
				<tr>
					<th>Date / time</th>
					<td><%=job == null ? "" : dateTimeFormatter.format(job.getEnded())%></td>
				</tr>
				<tr>
					<th>Plugin</th>
					<td><base:propertyvalue item="<%=design%>" property="job.pluginDefinition" /></td>
				</tr>
				<tr>
					<th>Configuration / file format</th>
					<td><base:propertyvalue item="<%=design%>" property="job.pluginConfiguration" /></td>
				</tr>
				<tr class="dynamic">
					<th></th>
					<td></td>
				</tr>
				</table>
			</td>
			</tr>
		</table>
		</div>
		<jsp:include page="../../common/datafiles/list_files.jsp">
			<jsp:param name="item_type" value="<%=itemType.name()%>" />
			<jsp:param name="item_id" value="<%=itemId%>" />
			<jsp:param name="ID" value="<%=ID%>" />
		</jsp:include>
			
		<%
		ItemQuery<ArrayBatch> batchQuery = design.getArrayBatches();
		batchQuery.include(Include.ALL);
		batchQuery.order(Orders.asc(Hql.property("name")));
		ItemResultList<ArrayBatch> batches = batchQuery.list(dc);
		%>
		<base:section 
			id="batches" 
			title="<%="Array batches (" + batches.size() +")"%>"
			context="<%=cc%>">
			<%
			if (batches.size() == 0)
			{
				%>
				<div class="messagecontainer note">
				No batches exists for this design
				(or, you don't have permission to view them).
				</div>
				<%
			}
			else
			{
				%>
				<tbl:table
					id="tbl.batches"
					columns="all"
					>
				<tbl:columndef 
					id="name"
					title="Name"
				/>
				<tbl:columndef 
					id="description"
					title="Description"
				/>
				<tbl:data>
					<tbl:headers>
						<tbl:headerrow>
							<tbl:columnheaders />
						</tbl:headerrow>
					</tbl:headers>
					<tbl:rows>
					<%
					for (ArrayBatch item : batches)
					{
						%>
						<tbl:row>
							<tbl:cell column="name"><base:icon 
									image="deleted.png" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=item.isRemoved()%>"
								/><%=Base.getLinkedName(ID, item, false, true)%></tbl:cell>
							<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
						</tbl:row>
						<%
					}
					%>
					</tbl:rows>
				</tbl:data>
				</tbl:table>
				<%
			}
			%>
		</base:section>
			
		<%
		ItemQuery<ArrayDesignPlate> platesQuery = design.getArrayDesignPlates();
		platesQuery.include(Include.ALL);
		platesQuery.order(Orders.asc(Hql.property("position")));
		ItemResultList<ArrayDesignPlate> plates = platesQuery.list(dc);
		%>
		<base:section 
			id="plates" 
			title="<%="Plates (" + plates.size() +")"%>" 
			context="<%=cc%>">
			<%
			if (plates.size() == 0)
			{
				%>
				<div class="messagecontainer note">
				This array design isn't connected to any plates (or, you don't have permission to view them).
				</div>
				<%
			}
			else
			{
				%>
				<tbl:table
					id="tbl.plates"
					columns="all"
					>
				<tbl:columndef 
					id="name"
					title="Name"
				/>
				<tbl:columndef 
					id="position"
					title="Position"
				/>
				<tbl:columndef 
					id="description"
					title="Description"
				/>
				<tbl:data>
					<tbl:headers>
						<tbl:headerrow>
							<tbl:columnheaders />
						</tbl:headerrow>
					</tbl:headers>
					<tbl:rows>
					<%
					for (ArrayDesignPlate item : plates)
					{
						Plate plate = null;
						boolean readPlate = true;
						try
						{
							plate = item.getPlate();
						}
						catch (PermissionDeniedException ex)
						{
							readPlate = false;
						}
						%>
						<tbl:row>
							<tbl:cell column="name"><base:icon 
									image="deleted.png" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=plate != null && plate.isRemoved()%>"
								/><%=Base.getLinkedName(ID, plate, !readPlate, true)%></tbl:cell>
							<tbl:cell column="position"><%=item.getPosition()+1%></tbl:cell>
							<tbl:cell column="description"><%=HTML.encodeTags(plate == null ? "" : plate.getDescription())%></tbl:cell>
						</tbl:row>
						<%
					}
					%>
					</tbl:rows>
				</tbl:data>
				</tbl:table>
				<%
			}
			%>
		</base:section>
		<jsp:include page="../../common/anytoany/list_anytoany.jsp">
			<jsp:param name="ID" value="<%=ID%>" />
			<jsp:param name="item_type" value="<%=itemType.name()%>" />
			<jsp:param name="item_id" value="<%=itemId%>" />
			<jsp:param name="title" value="Other items related to this array design" />
		</jsp:include>
		<jsp:include page="../../common/share/list_share.jsp">
			<jsp:param name="ID" value="<%=ID%>" />
			<jsp:param name="item_type" value="<%=itemType.name()%>" />
			<jsp:param name="item_id" value="<%=itemId%>" />
			<jsp:param name="title" value="Shared to" />
		</jsp:include>
		</t:tab>
			
		<t:tab id="annotations" title="Annotations" 
			tooltip="View annotation values" clazz="white">
				<jsp:include page="../../common/annotations/list_frameset.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
		</t:tab>
			
		<t:tab id="features" title="Features" visible="<%=design.getNumDbFeatures() > 0%>">
			<div class="bg-filled-50 absolutefull">
				<table style="margin: auto; height: 100%;"><tr><td>
				<b>Please wait. The features information is loading...</b>
				</td></tr></table>
			</div>
		</t:tab>

		<t:tab id="overview" title="Overview" 
			tooltip="Display a tree overview of related items">
			<jsp:include page="../../common/overview/overview.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
		</t:tab>
		<t:tab id="history" title="Change history" 
			tooltip="Displays a log of all modifications made to this item"
			visible="<%=ChangeHistoryUtil.showChangeHistoryTab(sc)%>">
			<jsp:include page="../../common/history/frameset.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
		</t:tab>
		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
